; 

      .686p                     ; create 32 bit code
      .MMX                      ; enable MMX instructions
      .XMM                      ; enable SSE instructions
      .model flat, stdcall      ; 32 bit memory model
      option casemap :none      ; case sensitive

      include Project.inc        ; local includes for this file

;###########################################################################################################
; Added
;###########################################################################################################

ChildProc PROTO  :HWND,:UINT,:WPARAM,:LPARAM

        .DATA

szChildClass db 'OurChildClass',0

        .DATA?

hChild       HWND ?
crct         RECT <>
cwc          WNDCLASSEX <>

;###########################################################################################################

.code

start:

; 

    ; ------------------
    ; set global values
    ; ------------------
      mov hInstance,   rv(GetModuleHandle, NULL)
      mov CommandLine, rv(GetCommandLine)
      mov hIcon,       rv(LoadIcon,hInstance,500)
      mov hCursor,     rv(LoadCursor,NULL,IDC_ARROW)
      mov sWid,        rv(GetSystemMetrics,SM_CXSCREEN)
      mov sHgt,        rv(GetSystemMetrics,SM_CYSCREEN)

      call Main

      invoke ExitProcess,eax

; 

Main proc

    LOCAL Wwd:DWORD,Wht:DWORD,Wtx:DWORD,Wty:DWORD
    LOCAL icce      :INITCOMMONCONTROLSEX

    mov icce.dwSize, SIZEOF INITCOMMONCONTROLSEX

  ; ------------------------------------------------------------------
  ; Add different cotrols by adding different styles to the icce.dwICC
  ; member of the INITCOMMONCONTROLSEX structure. Reference for the
  ; styles can be found in the INITCOMMONCONTROLSEX help information
  ; ------------------------------------------------------------------
    mov icce.dwICC,  ICC_COOL_CLASSES or ICC_BAR_CLASSES
    invoke InitCommonControlsEx,ADDR icce

;###########################################################################################################
; Added - register child window class
;###########################################################################################################

        mov     edx,offset cwc
        xor     eax,eax
        mov     [edx].WNDCLASSEX.cbSize,sizeof WNDCLASSEX
        mov     [edx].WNDCLASSEX.style,eax
        mov     [edx].WNDCLASSEX.lpfnWndProc,ChildProc
        mov     [edx].WNDCLASSEX.cbClsExtra,eax
        mov     [edx].WNDCLASSEX.cbWndExtra,eax
        push    hInstance
        pop     [edx].WNDCLASSEX.hInstance
        mov     [edx].WNDCLASSEX.hIcon,eax
        push    hCursor
        pop     [edx].WNDCLASSEX.hCursor
        mov     [edx].WNDCLASSEX.hbrBackground,COLOR_APPWORKSPACE+1
        mov     [edx].WNDCLASSEX.lpszMenuName,eax
        mov     [edx].WNDCLASSEX.lpszClassName,offset szChildClass
        mov     [edx].WNDCLASSEX.hIconSm,eax
        INVOKE  RegisterClassEx,edx

;###########################################################################################################

    STRING szClassName,"Prostart_Class"

  ; --------------------------------------------
  ; register class name for CreateWindowEx call
  ; --------------------------------------------
    invoke RegisterWinClass,ADDR WndProc,ADDR szClassName,
                       hIcon,hCursor,COLOR_BTNFACE+1

  ; -------------------------------------------------
  ; macro to autoscale window co-ordinates to screen
  ; percentages and centre window at those sizes.
  ; -------------------------------------------------
    AutoScale 70, 70

    invoke CreateWindowEx,WS_EX_LEFT,
                          ADDR szClassName,
                          ADDR szDisplayName,
                          WS_OVERLAPPEDWINDOW,
                          Wtx,Wty,Wwd,Wht,
                          NULL,NULL,
                          hInstance,NULL
    mov hWnd,eax

  ; ---------------------------
  ; macros for unchanging code
  ; ---------------------------
    DisplayWindow hWnd,SW_SHOWNORMAL

    call MsgLoop
    ret

Main endp

; 

RegisterWinClass proc lpWndProc:DWORD, lpClassName:DWORD,
                      Icon:DWORD, Cursor:DWORD, bColor:DWORD

    LOCAL wc:WNDCLASSEX

    mov wc.cbSize,         sizeof WNDCLASSEX
    mov wc.style,          CS_BYTEALIGNCLIENT or \
                           CS_BYTEALIGNWINDOW
    m2m wc.lpfnWndProc,    lpWndProc
    mov wc.cbClsExtra,     NULL
    mov wc.cbWndExtra,     NULL
    m2m wc.hInstance,      hInstance
    m2m wc.hbrBackground,  bColor
    mov wc.lpszMenuName,   NULL
    m2m wc.lpszClassName,  lpClassName
    m2m wc.hIcon,          Icon
    m2m wc.hCursor,        Cursor
    m2m wc.hIconSm,        Icon

    invoke RegisterClassEx, ADDR wc

    ret

RegisterWinClass endp

; 

MsgLoop proc

    LOCAL msg:MSG

    push esi
    push edi
    xor edi, edi                        ; clear EDI
    lea esi, msg                        ; Structure address in ESI
    jmp jumpin

    StartLoop:
      invoke TranslateMessage, esi
    ; --------------------------------------
    ; perform any required key processing here
    ; --------------------------------------
      invoke DispatchMessage,  esi
    jumpin:
      invoke GetMessage,esi,edi,edi,edi
      test eax, eax
      jnz StartLoop

    mov eax, msg.wParam
    pop edi
    pop esi

    ret

MsgLoop endp

; 

WndProc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    LOCAL var    :DWORD
    LOCAL caW    :DWORD
    LOCAL caH    :DWORD
    LOCAL Rct    :RECT
    LOCAL buffer1[260]:BYTE  ; these are two spare buffers
    LOCAL buffer2[260]:BYTE  ; for text manipulation etc..

    Switch uMsg
      Case WM_COMMAND

        Switch wParam
        ;======== toolbar commands ========
          Case 50
            fn MessageBox,hWin,"WM_COMMAND ID 50", \
                          ADDR szDisplayName,MB_OK
          Case 51
            fn MessageBox,hWin,"WM_COMMAND ID 51", \
                          ADDR szDisplayName,MB_OK
          Case 52
            fn MessageBox,hWin,"WM_COMMAND ID 52", \
                          ADDR szDisplayName,MB_OK
          Case 53
            fn MessageBox,hWin,"WM_COMMAND ID 53", \
                          ADDR szDisplayName,MB_OK
          Case 54
            fn MessageBox,hWin,"WM_COMMAND ID 54", \
                          ADDR szDisplayName,MB_OK
          Case 55
            fn MessageBox,hWin,"WM_COMMAND ID 55", \
                          ADDR szDisplayName,MB_OK
          Case 56
            fn MessageBox,hWin,"WM_COMMAND ID 56", \
                          ADDR szDisplayName,MB_OK
          Case 57
            fn MessageBox,hWin,"WM_COMMAND ID 57", \
                          ADDR szDisplayName,MB_OK
          Case 58
            fn MessageBox,hWin,"WM_COMMAND ID 58", \
                          ADDR szDisplayName,MB_OK

      Endsw

      Case WM_CREATE
        invoke Do_ToolBar,hWin

;###########################################################################################################
; Added
;###########################################################################################################

$childWinAttrs = WS_CHILD OR WS_CLIPSIBLINGS OR WS_VISIBLE

        xor     edx,edx
        INVOKE  CreateWindowEx,edx,offset szChildClass,edx,
                $childWinAttrs,edx,edx,edx,edx,hWin,edx,hInstance,edx
        mov     hChild,eax

;###########################################################################################################

      Case WM_SYSCOLORCHANGE
        invoke Do_ToolBar,hWin

      Case WM_SIZE
        invoke SendMessage,hToolBar,TB_AUTOSIZE,0,0

;###########################################################################################################
; Added
;###########################################################################################################

        push    esi
        mov     esi,offset crct
        INVOKE  GetClientRect,hWin,esi
        xor     edx,edx
        INVOKE  MoveWindow,hChild,edx,edx,[esi].RECT.right,[esi].RECT.bottom,TRUE
        pop     esi

;###########################################################################################################

      Case WM_PAINT
        invoke Paint_Proc,hWin
        return 0

      Case WM_CLOSE

      Case WM_DESTROY
        invoke PostQuitMessage,NULL
        return 0

    Endsw

    invoke DefWindowProc,hWin,uMsg,wParam,lParam

    ret

WndProc endp

;###########################################################################################################
; Added
;###########################################################################################################

ChildProc PROC hwnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

        INVOKE  DefWindowProc,hwnd,uMsg,wParam,lParam
        ret

ChildProc ENDP

;###########################################################################################################

; 

OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 

TopXY proc wDim:DWORD, sDim:DWORD

    mov eax, [esp+8]
    sub eax, [esp+4]
    shr eax, 1

    ret 8

TopXY endp

OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 

; 

Paint_Proc proc hWin:DWORD

    LOCAL hDC      :DWORD
    LOCAL btn_hi   :DWORD
    LOCAL btn_lo   :DWORD
    LOCAL Rct      :RECT
    LOCAL Ps       :PAINTSTRUCT

    mov hDC, rv(BeginPaint,hWin,ADDR Ps)

  ; ----------------------------------------

    mov btn_hi, rv(GetSysColor,COLOR_BTNHIGHLIGHT)

    mov btn_lo, rv(GetSysColor,COLOR_BTNSHADOW)

  ; ----------------------------------------

    invoke EndPaint,hWin,ADDR Ps

    ret

Paint_Proc endp

; 

Do_ToolBar proc hWin :DWORD

    ; ---------------------------------------
    ; This proc works by using macros so that 
    ; the code is easier to read and modify
    ; ---------------------------------------

    LOCAL bSize :DWORD
    LOCAL tbab  :TBADDBITMAP
    LOCAL tbb   :TBBUTTON

    ; ------------------
    ; The toolbar bitmap
    ; ~~~~~~~~~~~~~~~~~~
    ; You must supply a bitmap for the toolbar that has the 
    ; correct number of the required images, each of the same
    ; size and in the following strip bitmap form.
    ;
    ; For the bitmap to have the correct background color, there
    ; must be a 'path' for the FloodFill function from the top
    ; left corner AROUND each tool button image on the bitmap.

    ;  -------------------------------------
    ;  |  1  |  2  |  3  |  4  |  5  |  6  |
    ;  -------------------------------------

    ; ------------------------
    ; Uncomment following when
    ; bitmap has been created
    ; ------------------------
    ; invoke LoadBitmap,hInstance,750
    ; mov hTbBmp,eax

    ; --------------------------------------------------
    ; Set toolbar button dimensions here, width & height
    ; --------------------------------------------------
    Create_Tool_Bar 32, 32

    TBextraData     ; additional data for TBBUTTON structure

    ; -----------------------------------
    ; Add toolbar buttons and spaces here
    ; Syntax for the macro TBbutton is
    ; TBbutton bmpID number, WM_COMMAND ID number
    ; WM_COMMAND ID numbers start at 50
    ; -----------------------------------
    TBblank
    TBbutton  0,  50
    TBbutton  1,  51
    TBbutton  2,  52
    TBblank
    TBbutton  3,  53
    TBbutton  4,  54
    TBbutton  5,  55
    TBblank
    TBbutton  6,  56
    TBbutton  7,  57
    TBbutton  8,  58

    ret

Do_ToolBar endp

; 

SetBmpColor proc hBitmap:DWORD

    LOCAL mDC       :DWORD
    LOCAL hBrush    :DWORD
    LOCAL hOldBmp   :DWORD
    LOCAL hReturn   :DWORD
    LOCAL hOldBrush :DWORD

      invoke CreateCompatibleDC,NULL
      mov mDC,eax

      invoke SelectObject,mDC,hBitmap
      mov hOldBmp,eax

      invoke GetSysColor,COLOR_BTNFACE
      invoke CreateSolidBrush,eax
      mov hBrush,eax

      invoke SelectObject,mDC,hBrush
      mov hOldBrush,eax

      invoke GetPixel,mDC,1,1
      invoke ExtFloodFill,mDC,1,1,eax,FLOODFILLSURFACE

      invoke SelectObject,mDC,hOldBrush
      invoke DeleteObject,hBrush

      invoke SelectObject,mDC,hBitmap
      mov hReturn,eax
      invoke DeleteDC,mDC

      mov eax,hReturn

    ret

SetBmpColor endp

; 

end start
